# Ogre::NodeAnimationTrack Class Reference

Specialised AnimationTrack for dealing with node transforms. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::NodeAnimationTrack:

List of all members.

## Public Member Functions

| NodeAnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
| NodeAnimationTrack (Animation *parent, unsigned short handle, Node *targetNode)
| Constructor, associates with a Node.
virtual TransformKeyFrame * | createNodeKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual Node * | getAssociatedNode (void) const
| Returns a pointer to the associated Node object (if any).
virtual void | setAssociatedNode (Node *node)
| Sets the associated Node object which will be automatically affected by calls to 'apply'.
virtual void | applyToNode (Node *node, Real timePos, Real weight=1.0, bool accumulate=false, Real scale=1.0f)
| As the 'apply' method but applies to a specified Node instead of associated node.
virtual void | setUseShortestRotationPath (bool useShortestPath)
| Sets the method of rotation calculation.
virtual bool | getUseShortestRotationPath () const
| Gets the method of rotation calculation.
void | getInterpolatedKeyFrame (Real timeIndex, KeyFrame *kf) const

Remarks:
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters:

  | timeIndex | The time (in relation to the whole animation sequence)
  | kf | Keyframe object to store results

void | apply (Real timePos, Real weight=1.0, bool accumulate=false, Real scale=1.0f)

Parameters:

  | timePos | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | acculumate | Don't make weights relative to overall weights applied, make them absolute and just add.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

void | _keyFrameDataChanged (void) const
virtual TransformKeyFrame * | getNodeKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
virtual void | optimise (void)
| Optimise the current track by removing any duplicate keyframes.
NodeAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
unsigned short | getHandle (void) const
| Get the handle associated with this track.
virtual unsigned short | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
virtual KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual Real | getKeyFramesAtTime (Real timePos, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.

## Protected Types

typedef std::vector< KeyFrame * > | KeyFrameList

## Protected Member Functions

KeyFrame * | createKeyFrameImpl (Real time)
| Specialised keyframe creation.
virtual void | buildInterpolationSplines (void) const
virtual void | populateClone (AnimationTrack *clone) const
| Internal method for clone implementation.

## Protected Attributes

Node * | mTargetNode
bool | mSplineBuildNeeded
SimpleSpline | mPositionSpline
SimpleSpline | mScaleSpline
RotationalSpline | mRotationSpline
bool | mUseShortestRotationPath
| Defines if rotation is done using shortest path.
KeyFrameList | mKeyFrames
Animation * | mParent
unsigned short | mHandle

## Detailed Description

Specialised AnimationTrack for dealing with node transforms.

Definition at line 230 of file OgreAnimationTrack.h.

## Member Typedef Documentation

typedef std::vector<KeyFrame*> Ogre::AnimationTrack::KeyFrameList `[protected, inherited]`

| Definition at line 151 of file OgreAnimationTrack.h.

## Constructor & Destructor Documentation

Ogre::NodeAnimationTrack::NodeAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle
| ) |

| Constructor.

Ogre::NodeAnimationTrack::NodeAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | Node * | targetNode
| ) |

| Constructor, associates with a Node.

## Member Function Documentation

NodeAnimationTrack* Ogre::NodeAnimationTrack::_clone | ( | Animation * | newParent | ) | const

| Clone this track (internal use only).

void Ogre::NodeAnimationTrack::_keyFrameDataChanged | ( | void |  | ) | const`[virtual]`

| Reimplemented from Ogre::AnimationTrack.

void Ogre::NodeAnimationTrack::apply | ( | Real | timePos,
|  | Real | weight = `1.0`,
|  | bool | accumulate = `false`,
|  | Real | scale = `1.0f`
| ) | `[virtual]`

Parameters:

  | timePos | The time position in the animation to apply.
  | weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  | acculumate | Don't make weights relative to overall weights applied, make them absolute and just add.
  | scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::AnimationTrack.

virtual void Ogre::NodeAnimationTrack::applyToNode | ( | Node * | node,
|  | Real | timePos,
|  | Real | weight = `1.0`,
|  | bool | accumulate = `false`,
|  | Real | scale = `1.0f`
| ) | `[virtual]`

| As the 'apply' method but applies to a specified Node instead of associated node.

virtual void Ogre::NodeAnimationTrack::buildInterpolationSplines | ( | void |  | ) | const`[protected, virtual]`

virtual KeyFrame* Ogre::AnimationTrack::createKeyFrame | ( | Real | timePos | ) | `[virtual, inherited]`

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  | timePos | The time from which this KeyFrame will apply.

KeyFrame* Ogre::NodeAnimationTrack::createKeyFrameImpl | ( | Real | time | ) | `[protected, virtual]`

| Specialised keyframe creation. Implements Ogre::AnimationTrack.

virtual TransformKeyFrame* Ogre::NodeAnimationTrack::createNodeKeyFrame | ( | Real | timePos | ) | `[virtual]`

Creates a new KeyFrame and adds it to this animation at the given time index.

Remarks:
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters:

  | timePos | The time from which this KeyFrame will apply.

virtual Node* Ogre::NodeAnimationTrack::getAssociatedNode | ( | void |  | ) | const`[virtual]`

| Returns a pointer to the associated Node object (if any).

unsigned short Ogre::AnimationTrack::getHandle | ( | void |  | ) | const`[inherited]`

| Get the handle associated with this track. Definition at line 66 of file OgreAnimationTrack.h.

void Ogre::NodeAnimationTrack::getInterpolatedKeyFrame | ( | Real | timeIndex,
|  | KeyFrame * | kf
| ) | const`[virtual]`

Remarks:
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters:

  | timeIndex | The time (in relation to the whole animation sequence)
  | kf | Keyframe object to store results

Implements Ogre::AnimationTrack.

virtual KeyFrame* Ogre::AnimationTrack::getKeyFrame | ( | unsigned short | index | ) | const`[virtual, inherited]`

| Returns the KeyFrame at the specified index.

virtual Real Ogre::AnimationTrack::getKeyFramesAtTime | ( | Real | timePos,
|  | KeyFrame ** | keyFrame1,
|  | KeyFrame ** | keyFrame2,
|  | unsigned short * | firstKeyIndex = `0`
| ) | const`[virtual, inherited]`

Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.

Remarks:
  At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after.

  This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc.

Parameters:

  | timePos | The time index in seconds.
  | keyFrame1 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just before or at this time index.
  | keyFrame2 | Pointer to a KeyFrame pointer which will receive the pointer to the keyframe just after this time index.
  | firstKeyIndex | Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe incase the caller needs it.

Returns:
  Parametric value indicating how far along the gap between the 2 keyframes the timePos value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 <= returnValue < 1.0 .

virtual TransformKeyFrame* Ogre::NodeAnimationTrack::getNodeKeyFrame | ( | unsigned short | index | ) | const`[virtual]`

| Returns the KeyFrame at the specified index.

virtual unsigned short Ogre::AnimationTrack::getNumKeyFrames | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of keyframes in this animation.

virtual bool Ogre::NodeAnimationTrack::getUseShortestRotationPath | ( |  | ) | const`[virtual]`

| Gets the method of rotation calculation.

virtual bool Ogre::NodeAnimationTrack::hasNonZeroKeyFrames | ( | void |  | ) | const`[virtual]`

| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. Reimplemented from Ogre::AnimationTrack.

virtual void Ogre::NodeAnimationTrack::optimise | ( | void |  | ) | `[virtual]`

| Optimise the current track by removing any duplicate keyframes. Reimplemented from Ogre::AnimationTrack.

virtual void Ogre::AnimationTrack::populateClone | ( | AnimationTrack * | clone | ) | const`[protected, virtual, inherited]`

| Internal method for clone implementation.

virtual void Ogre::AnimationTrack::removeAllKeyFrames | ( | void |  | ) | `[virtual, inherited]`

| Removes all the KeyFrames from this track.

virtual void Ogre::AnimationTrack::removeKeyFrame | ( | unsigned short | index | ) | `[virtual, inherited]`

| Removes a KeyFrame by it's index.

virtual void Ogre::NodeAnimationTrack::setAssociatedNode | ( | Node * | node | ) | `[virtual]`

| Sets the associated Node object which will be automatically affected by calls to 'apply'.

virtual void Ogre::NodeAnimationTrack::setUseShortestRotationPath | ( | bool | useShortestPath | ) | `[virtual]`

| Sets the method of rotation calculation.

## Member Data Documentation

unsigned short Ogre::AnimationTrack::mHandle `[protected, inherited]`

| Definition at line 154 of file OgreAnimationTrack.h.

KeyFrameList Ogre::AnimationTrack::mKeyFrames `[protected, inherited]`

| Definition at line 152 of file OgreAnimationTrack.h.

Animation* Ogre::AnimationTrack::mParent `[protected, inherited]`

| Definition at line 153 of file OgreAnimationTrack.h.

SimpleSpline Ogre::NodeAnimationTrack::mPositionSpline `[mutable, protected]`

| Definition at line 297 of file OgreAnimationTrack.h.

RotationalSpline Ogre::NodeAnimationTrack::mRotationSpline `[mutable, protected]`

| Definition at line 299 of file OgreAnimationTrack.h.

SimpleSpline Ogre::NodeAnimationTrack::mScaleSpline `[mutable, protected]`

| Definition at line 298 of file OgreAnimationTrack.h.

bool Ogre::NodeAnimationTrack::mSplineBuildNeeded `[mutable, protected]`

| Definition at line 296 of file OgreAnimationTrack.h.

Node* Ogre::NodeAnimationTrack::mTargetNode `[protected]`

| Definition at line 294 of file OgreAnimationTrack.h.

bool Ogre::NodeAnimationTrack::mUseShortestRotationPath `[mutable, protected]`

| Defines if rotation is done using shortest path. Definition at line 301 of file OgreAnimationTrack.h.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Sep 17 15:39:20 2006